#include <iostream>
#include <bits/stdc++.h>

using namespace std;

struct Struct{
    long long node, energy;
};

bool operator <(Struct o1, Struct o2){
    if(o1.energy==o2.energy) {
        return o2.node < o1.node;
    }
    return o2.energy<o1.energy;
}

long long binary_search(long long x, vector<long long> &a){
    long long l = -1;
    long long r = a.size();
    while(r-l>1){
        long long m = (l+r)/2;
        if(m>=x){
            r=m;
        }
        else{
            l=m;
        }
    }
    return r;
}

long long gcd_ext(long long a, long long b, long long &x, long long y){
    if(b==0) {
        x = 1;
        y = 0;
        return a;
    }
    long long x1, y1;
    long long d = gcd_ext(b, a%b, x1, y1);
    x = y1;
    y=x1-y1*(a/b);
    return d;
}

void dfs(vector<vector<long long>> &g, vector<long long> &used, long long i){
    used[i]=1;
    for (auto elem:g[i]) {
        dfs(g,used, elem);
    }
}

void bfs(vector<vector<long long>> &g, vector<long long> &used, set<Struct> &st, vector<long long> &e){
    while(!st.empty()){
        Struct x = *st.begin();
        st.erase(st.begin());
        for(auto elem: g[x.node]){
            if(!used[elem]) {
                used[elem]=1;
                if(x.energy-1!=0) {
                    st.insert({elem, x.energy - 1});
                    e[elem]=x.energy-1;
                }
            }
            else if(used[elem] && x.energy-1>e[elem]){
                st.erase({elem, e[elem]});
                e[elem]=x.energy-1;
                st.insert({elem, e[elem]});
            }
        }
    }
}


int main() {
    long long n, m, k, a, b, p, h;
    cin >> n >> m >> k;
    vector<vector<long long>>g(n+1);
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    set<Struct> st;
    vector<long long> used(n+1);
    vector<long long> e(n+1);
    for (int i = 0; i < k; ++i) {
        cin >> p >> h;
        used[p]=1;
        e[p]=h;
        st.insert({p,h});
    }
    bfs(g, used, st, e);
    long long cnt = 0;
    vector<long long> ans;
    for (int i = 1; i < used.size(); ++i) {
        if(used[i]==1) {
            ans.push_back(i);
            cnt++;
        }
    }
    cout<<cnt<<"\n";
    for (int i = 0; i < ans.size(); ++i) {
        cout<<ans[i]<<" ";
    }
    return 0;
}